/* make emcas happy -*-C-*-  make emacs happy */
#include <Xbae/Matrix.h>

extern int wafeModifyVerifyCBset(
#if NeedFunctionPrototypes
   Boolean, int, int, int, String
#endif
);

static int
wafeMatrixEnterCellCBset(doit)
Boolean doit;
    {
    XbaeMatrixEnterCellCallbackStruct *cbs = 
	(XbaeMatrixEnterCellCallbackStruct *)wafeCurrentCallData;
    DBUG_ENTER("wafeMatrixEnterCellCBset");
    if (!cbs || cbs->reason !=  XbaeEnterCellReason) 
	DBUG_RETURN(wafeSetError("calling wafeMatrixEnterCellCBset is only valid from a enterCellCallback",NULL,NULL,NULL));
    cbs->doit = doit;
    DBUG_RETURN(TCL_OK);
    }

static int
wafeMatrixLeaveCellCBset(doit)
Boolean doit;
    {
    XbaeMatrixLeaveCellCallbackStruct *cbs = 
	(XbaeMatrixLeaveCellCallbackStruct *)wafeCurrentCallData;
    DBUG_ENTER("wafeMatrixLeaveCellCBset");
    if (!cbs || cbs->reason !=  XbaeLeaveCellReason) 
	DBUG_RETURN(wafeSetError("calling wafeMatrixLeaveCellCBset is only valid from a LeaveCellCallback",NULL,NULL,NULL));
    cbs->doit = doit;
    DBUG_RETURN(TCL_OK);
    }

static int
wafeMatrixTraverseCellCBset(nextRow,nextCol)
int nextRow;
int nextCol;
    {
    XbaeMatrixTraverseCellCallbackStruct *cbs = 
	(XbaeMatrixTraverseCellCallbackStruct *)wafeCurrentCallData;
    DBUG_ENTER("wafeMatrixTraverseCellCBset");
    if (!cbs || cbs->reason !=  XbaeTraverseCellReason) 
	DBUG_RETURN(wafeSetError("calling wafeMatrixTraverseCellCBset is only valid from a traverseCellCallback",NULL,NULL,NULL));
    cbs->next_row    = nextRow;
    cbs->next_column = nextCol;
    DBUG_RETURN(TCL_OK);
    }

static int
wafeMatrixModifyVerifyCBset(doit, currInsert, startPos, endPos, string)
Boolean doit;
long currInsert, startPos, endPos;
String string;
    {
    XbaeMatrixModifyVerifyCallbackStruct *cbs = 
	(XbaeMatrixModifyVerifyCallbackStruct *)wafeCurrentCallData;
    XtPointer saveCallData;
    
    DBUG_ENTER("wafeModifyVerifyCBset");
    if (!cbs || cbs->reason !=  XbaeModifyVerifyReason) 
	DBUG_RETURN(wafeSetError("calling wafeModifyVerifyCBset is only valid from a ModifyVerifyCallback",NULL,NULL,NULL));

    saveCallData = wafeCurrentCallData;
    wafeCurrentCallData = (XtPointer) cbs->verify;
    wafeModifyVerifyCBset(doit, currInsert, startPos, endPos, string);
    wafeCurrentCallData = saveCallData;

    DBUG_RETURN(TCL_OK);
    }


