#> The Motif Tree Widget (XsTree) was described by Douglas Young in
#> his book "X Window System Programming and Applications with Xt"
#> (Prentice Hall).  The sources for the Motif Tree widget with a few
#> fixes are distributed together with the Wafe package. The original
#> source can be obtained various ftp servers such as ftp.x.org.
#> 
#> The Motif Tree Widget requires Motif 1.1 or newer.

$PACKAGE = "MTREE";

~handles
           MTREE

#> The 'XsTree' widget class can be used to display tree structures
#> where each node in the tree can be of an arbitrary widget class.
#> The tree structure is defined over the resource 'superNode' which
#> is inhherited by all of its children.

~widgetClass
XsTree
	include <Tree.h>

#> The command 'XsScrolledTree' generates a XsTree widget inside of a
#> scrolled window (see alse XsTree).

~pseudoWidgetClass
XsScrolledTree
	className XsTree
	createCmd XsCreateScrolledTree


