proc XmCSText-type {} { return {creationCommand Widget}}
set wafeHelp(XmCSText) {
 Special percentcode subsititutions are performed for listed callbacks:
    %i: position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %n: new position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %f: startPos (from)
        losingFocusCallback, modifyVerifyCallback
    %t: endPos (to)
        losingFocusCallback, modifyVerifyCallback
    %s: text
        modifyVerifyCallback}

proc XmCSTextReplace-type {} { return {function {void} {in: XmCSTextWidget} {in: XmTextPosition} {in: XmTextPosition} {in: XmString} ## {Compound String Text widget} {from character position} {to character position} {insert string}}}

proc XmScrolledCSText-type {} { return {creationCommand XmCSText}}

proc XmComboBox-type {} { return {creationCommand Widget}}
set wafeHelp(XmComboBox) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: item or text
        selectionCallback
    %p: position
        selectionCallback}

proc XmContainer-type {} { return {creationCommand Widget}}
set wafeHelp(XmContainer) {
 Special percentcode subsititutions are performed for listed callbacks:
    %a: widget id of affected item
        outlineChangedCallback
    %S: widget IDs of selected items
        defaultActionCallback, selectionCallback}

proc XmContainerGetItemChildren-type {} { return {function {String} {in: XmContainerWidget} {in: Widget} ## {XmContainer widget} {parent widget}}}
set wafeHelp(XmContainerGetItemChildren) { The function 'XmContainerGetItemChildren' returns the list of
 widget IDs of the children of the specified widget (2nd argument)
 in the XmContainer widget (1st argument). A child is a widget
 having its 'entryParent' resource set to the specified widget. If
 the specified widget has no children, an empty string is returned.}

proc XmContainerRelayout-type {} { return {function {void} {in: XmContainerWidget} ## {XmContainer widget}}}
set wafeHelp(XmContainerRelayout) { The procedure 'XmContainerRelayout' forces repositioning of all
 items in the specified Container widget according to the item's
 positionIndex and entryParent resources.}

proc XmContainerReorder-type {} { return {function {void} {in: XmContainerWidget} {in: String} ## {XmContainer widget} {widget list}}}
set wafeHelp(XmContainerReorder) { The procedure 'XmContainerReorder' reorders the specified widgets
 according to their positionIndex constraint resource. If the
 'layoutType' resource of the container widget is OUTLINE or DETAIL,
 a re-layout of all items will be forced.}

proc XmIconGadget-type {} { return {creationCommand Widget}}

proc XmNotebook-type {} { return {creationCommand Widget}}
set wafeHelp(XmNotebook) {
 Special percentcode subsititutions are performed for listed callbacks:
    %p: page number of current page
        pageChangedCallback
    %i: widget id of current page
        pageChangedCallback
    %P: page number of previous page
        pageChangedCallback
    %I: widget id of previous page
        pageChangedCallback}

proc XmSpinBox-type {} { return {creationCommand Widget}}
set wafeHelp(XmSpinBox) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: string value
        modifyVerifyCallback, valueChangedCallback
    %a: widgetID of affected widget
        modifyVerifyCallback, valueChangedCallback
    %p: position
        modifyVerifyCallback, valueChangedCallback
    %b: crossed boundary
        modifyVerifyCallback, valueChangedCallback}

proc XmGetXmScreen-type {} { return {function {WidgetID} {in: XtScreen(Widget)} ## {widget to determine screen}}}
set wafeHelp(XmGetXmScreen) { The command 'XmGetXmScreen' returns the widgetID of the screen
 object associated with the specified widget.}

