proc XmAddTabGroup-type {} { return {function {void} {in: Widget} ## {widget to be added}}}

proc XmArrowButton-type {} { return {creationCommand Widget}}
set wafeHelp(XmArrowButton) {
 Special percentcode subsititutions are performed for listed callbacks:
    %c: click count
        activateCallback}

proc XmArrowButtonGadget-type {} { return {creationCommand Gadget}}
set wafeHelp(XmArrowButtonGadget) {
 Special percentcode subsititutions are performed for listed callbacks:
    %c: click count
        activateCallback}

proc XmBulletinBoard-type {} { return {creationCommand Widget}}

proc XmBulletinBoardDialog-type {} { return {creationCommand XmBulletinBoard}}

proc XmCascadeButton-type {} { return {creationCommand Widget}}

proc XmCascadeButtonGadget-type {} { return {creationCommand Gadget}}

proc XmCascadeButtonGadgetHighlight-type {} { return {function {void} {in: XmCascadeButtonGadget} {in: Boolean} ## {cascadeButtonGadget to be highlighted} {highlight (bool)}}}

proc XmCascadeButtonHighlight-type {} { return {function {void} {in: XmCascadeButtonGadget} {in: Boolean} ## {widget to be highlighted} {highlight (bool)}}}

proc XmCommand-type {} { return {creationCommand Widget}}
set wafeHelp(XmCommand) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: command string
        commandChangedCallback, commandEnteredCallback}

proc XmCommandAppendValue-type {} { return {function {void} {in: XmCommandWidget} {in: XmString} ## {command widget} {command string}}}

proc XmCommandError-type {} { return {function {void} {in: XmCommandWidget} {in: XmString} ## {command widget} {error message}}}

proc XmCommandGetChild-type {} { return {function {WidgetID} {in: XmCommandWidget} {in: (unsigned char)XmChild} ## {command widget} {child reference}}}

proc XmDialogShell-type {} { return {creationCommand Widget}}

proc XmDrawingArea-type {} { return {creationCommand Widget}}
set wafeHelp(XmDrawingArea) {
 Special percentcode subsititutions are performed for listed callbacks:
    %i: id of the window where event occured
        exposeCallback, inputCallback, resizeCallback}

proc XmDrawnButton-type {} { return {creationCommand Widget}}
set wafeHelp(XmDrawnButton) {
 Special percentcode subsititutions are performed for listed callbacks:
    %c: click count
        activateCallback
    %i: id of the window where event occured
        exposeCallback, resizeCallback}

proc XmErrorDialog-type {} { return {creationCommand XmMessageBox}}

proc XmFileSelectionBox-type {} { return {creationCommand Widget}}
set wafeHelp(XmFileSelectionBox) {
 Special percentcode subsititutions are performed for listed callbacks:
    %d: base directory
        okCallback, noMatchCallback, applyCallback, fileSearchProc, dirSearchProc
    %p: search pattern
        okCallback, noMatchCallback, applyCallback, fileSearchProc, dirSearchProc
    %m: value of dirMask
        okCallback, noMatchCallback, applyCallback, fileSearchProc, dirSearchProc
    %s: value of dirSpec
        okCallback, noMatchCallback, applyCallback, fileSearchProc, dirSearchProc}

proc XmFileSelectionBoxGetChild-type {} { return {function {WidgetID} {in: XmFileSelectionBoxWidget} {in: (unsigned char)XmChild} ## {file selection box widget} {child reference}}}

proc XmFileSelectionDialog-type {} { return {creationCommand XmFileSelectionBox}}

proc XmFileSelectionDoSearch-type {} { return {function {void} {in: XmFileSelectionBoxWidget} {in: XmString} ## {file selection box} {directory mask}}}

proc XmForm-type {} { return {creationCommand Widget}}

proc XmFormDialog-type {} { return {creationCommand XmForm}}

proc XmFrame-type {} { return {creationCommand Widget}}

proc XmGetDestination-type {} { return {function {WidgetID} {in: XtDisplay(Widget)} ## {any widget}}}
set wafeHelp(XmGetDestination) { The function 'XmGetDestination' returns the widget id of the widget
 that would be acted on by various selection operations (paste and
 Clipboard routines). The function returns 0 if there is no current
 destination (when no edit operations have been performed on a widget).}

proc XmInformationDialog-type {} { return {creationCommand XmMessageBox}}

proc XmLabel-type {} { return {creationCommand Widget}}

proc XmLabelGadget-type {} { return {creationCommand Gadget}}

proc XmList-type {} { return {creationCommand Widget}}
set wafeHelp(XmList) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: selected item
        browseSelectionCallback, defaultActionCallback, singleSelectionCallback
    %p: item position
        browseSelectionCallback, defaultActionCallback, singleSelectionCallback
    %S: selected items
        extendedSelectionCallback, multipleSelectionCallback
    %P: selected item positions
        extendedSelectionCallback, multipleSelectionCallback
    %n: number of selected items
        extendedSelectionCallback, multipleSelectionCallback
    %t: selection type
        browseSelectionCallback, defaultActionCallback, extendedSelectionCallback, multipleSelectionCallback, singleSelectionCallback}

proc XmListAddItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} {in: int} ## {List Widget} {Item to add} {Position}}}

proc XmListAddItems-type {} { return {function {void} {in: XmListWidget} {in: XmStringTable} {in: int} {in: int} ## {List Widget} {items} {number of items} {position}}}

proc XmListAddItemUnselected-type {} { return {function {void} {in: XmListWidget} {in: XmString} {in: int} ## {List Widget} {Item to add} {Position}}}

proc XmListDeleteAllItems-type {} { return {function {void} {in: XmListWidget} ## {List Widget}}}

proc XmListDeleteItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} ## {List Widget} {Item to delete}}}

proc XmListDeleteItems-type {} { return {function {void} {in: XmListWidget} {in: XmStringTable} {in: int} ## {List Widget} {items} {number of items}}}

proc XmListDeleteItemsPos-type {} { return {function {void} {in: XmListWidget} {in: int} {in: int} ## {List Widget} {number of items} {position of first item to be deleted}}}

proc XmListDeletePos-type {} { return {function {void} {in: XmListWidget} {in: int} ## {List Widget} {position of item}}}

proc XmListDeselectAllItems-type {} { return {function {void} {in: XmListWidget} ## {List Widget}}}

proc XmListDeselectItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} ## {List Widget} {item}}}

proc XmListDeselectPos-type {} { return {function {void} {in: XmListWidget} {in: int} ## {List Widget} {position of item}}}

proc XmListGetMatchPos-type {} { return {function {Boolean} {in: XmListWidget} {in: XmString} {out: list(int*,int)} ## {List Widget} {item} {list of positions}}}

proc XmListGetSelectedPos-type {} { return {function {Boolean} {in: XmListWidget} {out: list(int*,int)} ## {List Widget} {list of highlighted items}}}

proc XmListItemExists-type {} { return {function {Boolean} {in: XmListWidget} {in: XmString} ## {List Widget} {Item}}}

proc XmListItemPos-type {} { return {function {int} {in: XmListWidget} {in: XmString} ## {List Widget} {Item}}}

proc XmListReplaceItems-type {} { return {function {void} {in: XmListWidget} {in: XmStringTable} {in: int} {in: XmStringTable} ## {List Widget} {Items to be replaced} {number of items to be replaced} {new items}}}

proc XmListReplaceItemsPos-type {} { return {function {void} {in: XmListWidget} {in: XmStringTable} {in: int} {in: int} ## {List Widget} {New items} {number of items to be replaced} {first Pos of items to be replaced}}}

proc XmListSelectItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} {in: Boolean} ## {List Widget} {item to highlight} {Invoke callback yes/no}}}

proc XmListSelectPos-type {} { return {function {void} {in: XmListWidget} {in: int} {in: Boolean} ## {List Widget} {Position of item} {Invoke callback yes/no}}}

proc XmListSetAddMode-type {} { return {function {void} {in: XmListWidget} {in: Boolean} ## {List Widget} {Use Add Mode yes/no}}}

proc XmListSetBottomItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} ## {List Widget} {item to be displayed as last item}}}

proc XmListSetBottomPos-type {} { return {function {void} {in: XmListWidget} {in: int} ## {List Widget} {item to be displayed as last item}}}

proc XmListSetHorizPos-type {} { return {function {void} {in: XmListWidget} {in: int} ## {List Widget} {horizontal Position}}}

proc XmListSetItem-type {} { return {function {void} {in: XmListWidget} {in: XmString} ## {List Widget} {item}}}

proc XmListSetPos-type {} { return {function {void} {in: XmListWidget} {in: int} ## {List Widget} {Position}}}

proc XmMainWindow-type {} { return {creationCommand Widget}}

proc XmMainWindowSetAreas-type {} { return {function {void} {in: XmMainWindowWidget} {in: NULL | Widget} {in: NULL | Widget} {in: NULL | Widget} {in: NULL | Widget} {in: NULL | Widget} ## {main window widget} {menu bar widget} {command window widget} {horizontal scrollbar widget} {vertical scrollbar widget} {work region widget}}}

proc XmMenuBar-type {} { return {creationCommand XmRowColumn}}

proc XmMenuShell-type {} { return {creationCommand Widget}}

proc XmMenuPosition-type {} { return {function {void} {in: Widget} {const: (XButtonPressedEvent *) wafeCurrentEvent} ## {menu widget}}}

proc XmMessageBox-type {} { return {creationCommand Widget}}

proc XmMessageBoxGetChild-type {} { return {function {WidgetID} {in: XmMessageBoxWidget} {in: (unsigned char)XmChild} ## {message box widget} {child reference}}}

proc XmMessageDialog-type {} { return {creationCommand XmMessageBox}}

proc XmOptionMenu-type {} { return {creationCommand XmRowColumn}}

proc XmPanedWindow-type {} { return {creationCommand Widget}}

proc XmPopupMenu-type {} { return {creationCommand XmRowColumn}}

proc XmProcessTraversal-type {} { return {function {Boolean} {in: Widget} {in: (int) XmTravDir} ## {Widget for which to traverse hierarchy} {direction in which to traverse widget hierarchy}}}

proc XmPromptDialog-type {} { return {creationCommand XmSelectionBox}}

proc XmPulldownMenu-type {} { return {creationCommand XmRowColumn}}

proc XmPushButton-type {} { return {creationCommand Widget}}
set wafeHelp(XmPushButton) {
 Special percentcode subsititutions are performed for listed callbacks:
    %c: click count
        activateCallback}

proc XmPushButtonGadget-type {} { return {creationCommand Gadget}}
set wafeHelp(XmPushButtonGadget) {
 Special percentcode subsititutions are performed for listed callbacks:
    %c: click count
        activateCallback}

proc XmQuestionDialog-type {} { return {creationCommand XmMessageBox}}

proc XmRadioBox-type {} { return {creationCommand XmRowColumn}}

proc XmRowColumn-type {} { return {creationCommand Widget}}
set wafeHelp(XmRowColumn) {
 Special percentcode subsititutions are performed for listed callbacks:
    %e: widgetID where entry occured
        entryCallback}

proc XmScale-type {} { return {creationCommand Widget}}
set wafeHelp(XmScale) {
 Special percentcode subsititutions are performed for listed callbacks:
    %v: value
        dragCallback, valueChangedCallback}

proc XmScaleSetTicks-type {} { return {function {void} {in: XmScaleWidget} {in: int} {in: Cardinal} {in: Cardinal} {in: Dimension} {in: Dimension} {in: Dimension} ## {XmScale widget} {number of scale values between big ticks} {number of medium ticks between big values} {number of small ticks between medium values} {size of big ticks} {size of medium ticks} {size of small ticks}}}
set wafeCmdNeeds(XmScaleSetTicks) {MOTIF20 }
set wafeHelp(XmScaleSetTicks) { The command 'XmScaleSetTicks' controls the number, location and
 size of the tick marks on a scale. Each tick mark is implemented as
 a separator gadget. If tick marks are specified and the orientation
 of the XmScale widget is changed, it is necessary to destroy all
 children of the XmScale widget and to recreate new tick marks using
 XmScaleSetTicks again.}

proc XmScrollBar-type {} { return {creationCommand Widget}}
set wafeHelp(XmScrollBar) {
 Special percentcode subsititutions are performed for listed callbacks:
    %p: pixel
        toBottomCallback, toTopCallback
    %v: value
        decrementCallback, dragCallback, incrementCallback, pageDecrementCallback, pageIncrementCallback, toBottomCallback, toTopCallback, valueChangedCallback}

proc XmScrollBarGetValues-type {} { return {function {void} {in: XmScrollBarWidget} {out: int} {out: int} {out: int} {out: int} ## {scrollbar widget} {value (slider position)} {slider size} {increment (smallest movement)} {page increment}}}

proc XmScrollBarSetValues-type {} { return {function {void} {in: XmScrollBarWidget} {in: int} {in: int} {in: int} {in: int} {in: Boolean} ## {scrollbar widget} {value (slider position)} {slider size} {increment (smallest movement)} {page increment} {notify}}}

proc XmScrolledList-type {} { return {creationCommand XmList}}

proc XmScrolledText-type {} { return {creationCommand XmText}}

proc XmScrolledWindow-type {} { return {creationCommand Widget}}

proc XmScrollVisible-type {} { return {function {void} {in: XmScrolledWindowWidget} {in: Widget} {in: Dimension} {in: Dimension} ## {scrolled window} {widget to be made visible} {left-right margin for positioning} {top-botton margin for positioning}}}
set wafeCmdNeeds(XmScrollVisible) {MOTIF12 }

proc XmSelectionBox-type {} { return {creationCommand Widget}}
set wafeHelp(XmSelectionBox) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: value
        applyCallback, noMatchCallback, okCallback}

proc XmSelectionBoxGetChild-type {} { return {function {WidgetID} {in: XmSelectionBoxWidget} {in: (unsigned char)XmChild} ## {selection box widget} {child reference}}}

proc XmSelectionDialog-type {} { return {creationCommand XmSelectionBox}}

proc XmSeparator-type {} { return {creationCommand Widget}}

proc XmSeparatorGadget-type {} { return {creationCommand Gadget}}

proc XmSimpleCheckBox-type {} { return {creationCommand XmRowColumn}}

proc XmSimpleMenuBar-type {} { return {creationCommand XmRowColumn}}

proc XmSimpleOptionMenu-type {} { return {creationCommand XmRowColumn}}

proc XmSimplePopupMenu-type {} { return {creationCommand XmRowColumn}}

proc XmSimplePulldownMenu-type {} { return {creationCommand XmRowColumn}}

proc XmSimpleRadioBox-type {} { return {creationCommand XmRowColumn}}

proc XmText-type {} { return {creationCommand Widget}}
set wafeHelp(XmText) {
 Special percentcode subsititutions are performed for listed callbacks:
    %i: position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %n: new position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %f: startPos (from)
        losingFocusCallback, modifyVerifyCallback
    %t: endPos (to)
        losingFocusCallback, modifyVerifyCallback
    %s: text
        modifyVerifyCallback}

proc XmTextClearSelection-type {} { return {function {void} {in: XmTextWidget} {const: time(NULL)} ## {Text widget}}}

proc XmTextCopy-type {} { return {function {Boolean} {in: XmTextWidget} {const: time(NULL)} ## {Text widget}}}

proc XmTextCut-type {} { return {function {Boolean} {in: XmTextWidget} {const: time(NULL)} ## {Text widget}}}

proc XmTextDisableRedisplay-type {} { return {function {void} {in: XmTextWidget} ## {XmText widget}}}
set wafeCmdNeeds(XmTextDisableRedisplay) {MOTIF12 }

proc XmTextEnableRedisplay-type {} { return {function {void} {in: XmTextWidget} ## {XmText widget}}}
set wafeCmdNeeds(XmTextEnableRedisplay) {MOTIF12 }

proc XmTextField-type {} { return {creationCommand Widget}}
set wafeHelp(XmTextField) {
 Special percentcode subsititutions are performed for listed callbacks:
    %i: position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %n: new position of insert cursor
        losingFocusCallback, modifyVerifyCallback, motionVerifyCallback
    %f: startPos (from)
        losingFocusCallback, modifyVerifyCallback
    %t: endPos (to)
        losingFocusCallback, modifyVerifyCallback
    %s: text
        modifyVerifyCallback}

proc XmTextFieldClearSelection-type {} { return {function {void} {in: XmTextFieldWidget} {const: time(NULL)} ## {Text field widget}}}

proc XmTextFieldCopy-type {} { return {function {Boolean} {in: XmTextFieldWidget} {const: time(NULL)} ## {Text field widget}}}

proc XmTextFieldCut-type {} { return {function {Boolean} {in: XmTextFieldWidget} {const: time(NULL)} ## {Text field widget}}}

proc XmTextFieldGetBaseline-type {} { return {function {int} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldGetLastPosition-type {} { return {function {XmTextPosition} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldGetSelection-type {} { return {function {String} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldGetSelectionPosition-type {} { return {function {Boolean} {in: XmTextFieldWidget} {out: XmTextPosition} {out: XmTextPosition} ## {Text field widget} {left boundary} {right boundary}}}

proc XmTextFieldGetString-type {} { return {function {String} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldInsert-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} {in: String} ## {Text field widget} {character position} {text string to be inserted}}}

proc XmTextFieldPaste-type {} { return {function {Boolean} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldPosToXY-type {} { return {function {Boolean} {in: XmTextFieldWidget} {in: XmTextPosition} {out: Position} {out: Position} ## {Text field widget} {character position} {x coord relative to top left} {y coord relative to top left}}}

proc XmTextFieldRemove-type {} { return {function {Boolean} {in: XmTextFieldWidget} ## {Text field widget}}}

proc XmTextFieldReplace-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} {in: XmTextPosition} {in: String} ## {Text field widget} {from character position} {to character position} {insert string}}}

proc XmTextFieldSetAddMode-type {} { return {function {void} {in: XmTextFieldWidget} {in: Boolean} ## {Text field widget} {true | false}}}

proc XmTextFieldSetHighlight-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} {in: XmTextPosition} {in: XmHighlightMode} ## {Text field widget} {from character position} {to character position} {HIGHLIGHT_NORMAL | HIGHLIGHT_SELECTED | HIGHLIGHT_SECONDARY_SELECTED}}}

proc XmTextFieldSetInsertionPosition-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} ## {Text field widget} {character position}}}

proc XmTextFieldSetSelection-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} {in: XmTextPosition} {const: time(NULL)} ## {Text field widget} {from character position} {to character position}}}

proc XmTextFieldShowPosition-type {} { return {function {void} {in: XmTextFieldWidget} {in: XmTextPosition} ## {Text field widget} {character position to display}}}

proc XmTextFieldXYToPos-type {} { return {function {void} {in: XmTextFieldWidget} {in: Position} {in: Position} ## {Text field widget} {x coord relative to top left} {y coord relative to top left}}}

proc XmTextFindString-type {} { return {function {Boolean} {in: XmTextWidget} {in: XmTextPosition} {in: String} {in: XmTextDirection} {out: XmTextPosition} ## {XmText widget} {start position} {search string} {TEXT_FORWARD | TEXT_BACKWARD} {start position of the found string}}}
set wafeCmdNeeds(XmTextFindString) {MOTIF12 }

proc XmTextGetBaseline-type {} { return {function {int} {in: XmTextWidget} ## {Text widget}}}

proc XmTextGetLastPosition-type {} { return {function {XmTextPosition} {in: XmTextWidget} ## {Text widget}}}

proc XmTextGetSelection-type {} { return {function {String} {in: XmTextWidget} ## {Text widget}}}

proc XmTextGetSelectionPosition-type {} { return {function {Boolean} {in: XmTextWidget} {out: XmTextPosition} {out: XmTextPosition} ## {Text widget} {left boundary} {right boundary}}}

proc XmTextGetString-type {} { return {function {String} {in: XmTextWidget} ## {Text widget}}}

proc XmTextInsert-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} {in: String} ## {Text widget} {character position} {text string to be inserted}}}

proc XmTextPaste-type {} { return {function {Boolean} {in: XmTextWidget} ## {Text widget}}}

proc XmTextPosToXY-type {} { return {function {Boolean} {in: XmTextWidget} {in: XmTextPosition} {out: Position} {out: Position} ## {Text widget} {character position} {x coord relative to top left} {y coord relative to top left}}}

proc XmTextRemove-type {} { return {function {Boolean} {in: XmTextWidget} ## {Text widget}}}

proc XmTextReplace-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} {in: XmTextPosition} {in: String} ## {Text widget} {from character position} {to character position} {insert string}}}

proc XmTextScroll-type {} { return {function {void} {in: XmTextWidget} {in: int} ## {Text widget} {number of lines to scroll}}}

proc XmTextSetAddMode-type {} { return {function {void} {in: XmTextWidget} {in: Boolean} ## {Text widget} {true | false}}}

proc XmTextSetHighlight-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} {in: XmTextPosition} {in: XmHighlightMode} ## {Text widget} {from character position} {to character position} {HIGHLIGHT_NORMAL | HIGHLIGHT_SELECTED | HIGHLIGHT_SECONDARY_SELECTED}}}

proc XmTextSetInsertionPosition-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} ## {Text widget} {character position}}}

proc XmTextSetSelection-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} {in: XmTextPosition} {const: time(NULL)} ## {Text widget} {from character position} {to character position}}}

proc XmTextShowPosition-type {} { return {function {void} {in: XmTextWidget} {in: XmTextPosition} ## {Text widget} {character position to display}}}

proc XmTextXYToPos-type {} { return {function {void} {in: XmTextWidget} {in: Position} {in: Position} ## {Text widget} {x coord relative to top left} {y coord relative to top left}}}

proc XmToggleButton-type {} { return {creationCommand Widget}}
set wafeHelp(XmToggleButton) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: state
        valueChangedCallback}

proc XmToggleButtonGetState-type {} { return {function {Boolean} {in: XmToggleButtonWidget} ## {toggle button widget}}}

proc XmToggleButtonSetState-type {} { return {function {void} {in: XmToggleButtonWidget} {in: Boolean} {in: Boolean} ## {toggle button widget} {state (bool)} {notify (bool)}}}

proc XmToggleButtonGadget-type {} { return {creationCommand Gadget}}
set wafeHelp(XmToggleButtonGadget) {
 Special percentcode subsititutions are performed for listed callbacks:
    %s: state
        valueChangedCallback}

proc XmToggleButtonGadgetGetState-type {} { return {function {Boolean} {in: XmToggleButtonGadget} ## {toggle button gadget}}}

proc XmToggleButtonGadgetSetState-type {} { return {function {void} {in: XmToggleButtonGadget} {in: Boolean} {in: Boolean} ## {toggle button gadget} {state (bool)} {notify (bool)}}}

proc XmUpdateDisplay-type {} { return {function {void} {in: Widget} ## {widget to determine display}}}

proc XmWarningDialog-type {} { return {creationCommand XmMessageBox}}

proc XmWorkingDialog-type {} { return {creationCommand XmMessageBox}}

proc XmAddProtocol-type {} { return {function {void} {in: Widget} {in: name2AtomNdsp(String)} {in: name2AtomNdsp(String)} ## {widget associated with protocol} {property atom} {protocol atom}}}

proc XmAddProtocolCallback-type {} { return {function {void} {in: Widget} {in: name2AtomNdsp(String)} {in: name2AtomNdsp(String)} {in: String} ## {widget associated with protocol} {property atom} {protocol atom} {command to be executed}}}

proc XmActivateProtocol-type {} { return {function {void} {in: Widget} {in: name2AtomNdsp(String)} {in: name2AtomNdsp(String)} ## {widget associated with protocol} {property atom} {protocol atom}}}

proc XmDeactivateProtocol-type {} { return {function {void} {in: Widget} {in: name2AtomNdsp(String)} {in: name2AtomNdsp(String)} ## {widget associated with protocol} {property atom} {protocol atom}}}

proc XmTextSetSelectionArray-type {} { return {function {void} {in: XmTextWidget} {const: argc-2} {in: [XmTextScanType]} ## {motif text widget} {selection array}}}
set wafeHelp(XmTextSetSelectionArray) { The procedure 'XmTextSetSelectionArray' sets the selection array
 for the specified XmText widget. The selection array determines the
 selection behavior on single, double, triple and so on clicks with
 the left mouse button in the text widget. The nth position in this
 array determines the behavior on the nth click. Possible values in
 this array are: SELECT_POSITION, SELECT_WHITESPACE, SELECT_WORD,
 SELECT_LINE, SELECT_PARAGRAPH and SELECT_ALL.
 
 Example:    XmTextSetSelectionArray $w SELECT_WORD SELECT_LINE}

proc XmTextFieldSetSelectionArray-type {} { return {function {void} {in: XmTextFieldWidget} {const: argc-2} {in: [XmTextScanType]} ## {motif text field widget} {selection array}}}
set wafeHelp(XmTextFieldSetSelectionArray) { The procedure 'XmTextFieldSetSelectionArray' sets the selection
 array for the specified XmTextField widget. The selection array
 determines the selection behavior on single, double, triple and so
 on clicks with the left mouse button in the text widget. The nth
 position in this array determines the behavior on the nth
 click. Possible values in this array are: SELECT_POSITION,
 SELECT_WHITESPACE, SELECT_WORD, SELECT_LINE, SELECT_PARAGRAPH and
 SELECT_ALL.
 
 Example:    XmTextFieldSetSelectionArray $w SELECT_WORD SELCT_LINE}

proc XmModifyVerifyCBset-type {} { return {function {void} {in: Boolean} {in: long} {in: long} {in: long} {in: String} ## {doit} {currInsert} {startPos} {endPos} {String}}}

proc XmInstallImage-type {} { return {function {Boolean} {in: XtDisplay(Widget)} {in: String} {in: String} {const: False} {const: NULL} ## {widget to determine display} {filename or data} {short name}}}

proc XmGetString-type {} { return {function {String} {in: Widget} {in: String} ## {widget} {resource name}}}
set wafeHelp(XmGetString) { The function 'XmGetString' returns the value of the specified
 resource (which must be of type XmString or String) in the
 specified widget in form of a string without any tags.}

proc XmChangeColor-type {} { return {function {void} {in: Widget} {in: Pixel} ## {widget} {color string for background}}}

